local finalecount = 0
local finalestage = 0

local chance = P_RandomChance(FRACUNIT/128)

COM_AddCommand("speckiii", function(p, arg)
	if string.sub(arg, 1, 2) == "42" then
		chance = true
		
		if S_MusicName(displayplayer) == "_title" then
			S_ChangeMusic("TITLES", true, displayplayer)
		elseif S_MusicName(displayplayer) == "_chsel" then
			S_ChangeMusic("CHRSEL", true, displayplayer)
		end
	elseif string.sub(arg, 1, 2) == "20" then
		chance = false
		
		if S_MusicName(displayplayer) == "TITLES" then
			S_ChangeMusic("_title", false, displayplayer)
		elseif S_MusicName(displayplayer) == "CHRSEL" then
			S_ChangeMusic("_chsel", true, displayplayer)
		end
	end
end)

local kimoList = {
	["_title"] = "TITLES",
	["_chsel"] = "CHRSEL"
}

addHook("MusicChange", function(old, new)
	if chance then
		if kimoList[new] ~= nil then
			return kimoList[new]
		else
			return new
		end
	end
end)

addHook("ThinkFrame", do
	if gamestate == GS_TITLESCREEN then
		finalecount = $ + 1
		finalestage = $ + 8
	elseif gamestate ~= GS_TITLESCREEN then
		finalecount = 0
		finalestage = 0
	end
end)

local function F_SkyScroll(v)
    local scrolled
	local pat

	if not chance then
		pat = v.cachePatch("TITLESKY");
	else
		pat = v.cachePatch("KIMOSKY");
	end

    local animtimer = finalecount % 64;

    scrolled = 320 - (animtimer)*5;
    if(scrolled > 320)
        scrolled = 320;
	end
    if(scrolled < 0)
        scrolled = 0;
	end

    if(scrolled > 0)
        v.draw(320 - scrolled, 0,  pat);
	end

    if(scrolled < 320)
        v.draw(-scrolled, 0, pat);
	end
end

local ttwing
local ttspop1
local ttspop2
local ttspop3
local ttspop4
local ttspop5
local ttspop6
local ttspop7
local ttsprep1
local ttsprep2
local ttswip1
local ttsonic
local ttswave1
local ttswave2
local ttbanner

hud.add(function(v)
	if not chance then
		ttwing = v.cachePatch("TTWING")
		ttspop1 = v.cachePatch("TTSPOP1")
		ttspop2 = v.cachePatch("TTSPOP2")
		ttspop3 = v.cachePatch("TTSPOP3")
		ttspop4 = v.cachePatch("TTSPOP4")
		ttspop5 = v.cachePatch("TTSPOP5")
		ttspop6 = v.cachePatch("TTSPOP6")
		ttspop7 = v.cachePatch("TTSPOP7")
		ttsprep1 = v.cachePatch("TTSPREP1")
		ttsprep2 = v.cachePatch("TTSPREP2")
		ttswip1 = v.cachePatch("TTSWIP1")
		ttsonic = v.cachePatch("TTSONIC")
		ttswave1 = v.cachePatch("TTSWAVE1")
		ttswave2 = v.cachePatch("TTSWAVE2")
		ttbanner = v.cachePatch("TTBANNER")
	else
		ttwing = v.cachePatch("KIWING")
		ttspop1 = v.cachePatch("KKSPOP1")
		ttspop2 = v.cachePatch("KKSPOP2")
		ttspop3 = v.cachePatch("KKSPOP3")
		ttspop4 = v.cachePatch("KKSPOP4")
		ttspop5 = v.cachePatch("KKSPOP5")
		ttspop6 = v.cachePatch("KKSPOP6")
		ttspop7 = v.cachePatch("KKSPOP7")
		ttsprep1 = v.cachePatch("KKSPREP1")
		ttsprep2 = v.cachePatch("KKSPREP2")
		ttswip1 = v.cachePatch("KKSWIP1")
		ttsonic = v.cachePatch("KISONIC")
		ttswave1 = v.cachePatch("KKSWAVE1")
		ttswave2 = v.cachePatch("KKSWAVE2")
		ttbanner = v.cachePatch("KIBANNER")
	end
	
	F_SkyScroll(v)

	v.draw(30, 14, ttwing);

	if(finalecount < 57)
		if(finalecount == 35)
			v.draw(115, 15, ttspop1);
		elseif(finalecount == 36)
			v.draw(114, 15, ttspop2);
		elseif(finalecount == 37)
			v.draw(113, 15, ttspop3);
		elseif(finalecount == 38)
			v.draw(112, 15, ttspop4);
		elseif(finalecount == 39)
			v.draw(111, 15, ttspop5);
		elseif(finalecount == 40)
			v.draw(110, 15, ttspop6);
		elseif(finalecount >= 41 and finalecount <= 44)
			v.draw(109, 15, ttspop7);
		elseif(finalecount >= 45 and finalecount <= 48)
			v.draw(108, 12, ttsprep1);
		elseif(finalecount >= 49 and finalecount <= 52)
			v.draw(107, 9, ttsprep2);
		elseif(finalecount >= 53 and finalecount <= 56)
			v.draw(106, 6, ttswip1);
		end
		v.draw(93, 106, ttsonic);
	else
		v.draw(93, 106, ttsonic);
		if(finalecount/5 & 1)
			v.draw(100, 3, ttswave1);
		else
			v.draw(100, 3, ttswave2);
		end
	end

	v.draw(48, 142, ttbanner);
end, "title")